import { vitest } from 'vitest';
import { type RouteLocation } from 'vue-router';

import { type MountingOptions, shallowMount } from '@vue/test-utils';
import sinon, { type SinonStubbedInstance } from 'sinon';

import AlertService from '@/shared/alert/alert.service';

import ConfermaDetails from './conferma-details.vue';
import ConfermaService from './conferma.service';

type ConfermaDetailsComponentType = InstanceType<typeof ConfermaDetails>;

let route: Partial<RouteLocation>;
const routerGoMock = vitest.fn();

vitest.mock('vue-router', () => ({
  useRoute: () => route,
  useRouter: () => ({ go: routerGoMock }),
}));

const confermaSample = { id: 123 };

describe('Component Tests', () => {
  let alertService: AlertService;

  afterEach(() => {
    vitest.resetAllMocks();
  });

  describe('Conferma Management Detail Component', () => {
    let confermaServiceStub: SinonStubbedInstance<ConfermaService>;
    let mountOptions: MountingOptions<ConfermaDetailsComponentType>['global'];

    beforeEach(() => {
      route = {};
      confermaServiceStub = sinon.createStubInstance<ConfermaService>(ConfermaService);

      alertService = new AlertService({
        i18n: { t: vitest.fn() } as any,
        toast: {
          show: vitest.fn(),
        } as any,
      });

      mountOptions = {
        stubs: {
          'font-awesome-icon': true,
          'router-link': true,
        },
        provide: {
          alertService,
          confermaService: () => confermaServiceStub,
        },
      };
    });

    describe('Navigate to details', () => {
      it('Should call load all on init', async () => {
        // GIVEN
        confermaServiceStub.find.resolves(confermaSample);
        route = {
          params: {
            confermaId: `${123}`,
          },
        };
        const wrapper = shallowMount(ConfermaDetails, { global: mountOptions });
        const comp = wrapper.vm;
        // WHEN
        await comp.$nextTick();

        // THEN
        expect(comp.conferma).toMatchObject(confermaSample);
      });
    });

    describe('Previous state', () => {
      it('Should go previous state', async () => {
        confermaServiceStub.find.resolves(confermaSample);
        const wrapper = shallowMount(ConfermaDetails, { global: mountOptions });
        const comp = wrapper.vm;
        await comp.$nextTick();

        comp.previousState();
        await comp.$nextTick();

        expect(routerGoMock).toHaveBeenCalledWith(-1);
      });
    });
  });
});
